const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Modelos_bim_asbuiltDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const modelos_bim_asbuilt = await db.modelos_bim_asbuilt.create(
      {
        id: data.id || undefined,

        nome_modelo: data.nome_modelo || null,
        descricao: data.descricao || null,
        arquivo_modelo: data.arquivo_modelo || null,
        formato: data.formato || null,
        plataforma_origem: data.plataforma_origem || null,
        data_modelagem: data.data_modelagem || null,
        responsavel_modelagem: data.responsavel_modelagem || null,
        nivel_detalhamento: data.nivel_detalhamento || null,
        coordenacao_com_outros_modelos:
          data.coordenacao_com_outros_modelos || false,

        comentarios: data.comentarios || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await modelos_bim_asbuilt.setObra(data.obra || null, {
      transaction,
    });

    await modelos_bim_asbuilt.setClientes(data.clientes || null, {
      transaction,
    });

    return modelos_bim_asbuilt;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const modelos_bim_asbuiltData = data.map((item, index) => ({
      id: item.id || undefined,

      nome_modelo: item.nome_modelo || null,
      descricao: item.descricao || null,
      arquivo_modelo: item.arquivo_modelo || null,
      formato: item.formato || null,
      plataforma_origem: item.plataforma_origem || null,
      data_modelagem: item.data_modelagem || null,
      responsavel_modelagem: item.responsavel_modelagem || null,
      nivel_detalhamento: item.nivel_detalhamento || null,
      coordenacao_com_outros_modelos:
        item.coordenacao_com_outros_modelos || false,

      comentarios: item.comentarios || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const modelos_bim_asbuilt = await db.modelos_bim_asbuilt.bulkCreate(
      modelos_bim_asbuiltData,
      { transaction },
    );

    // For each item created, replace relation files

    return modelos_bim_asbuilt;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const modelos_bim_asbuilt = await db.modelos_bim_asbuilt.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.nome_modelo !== undefined)
      updatePayload.nome_modelo = data.nome_modelo;

    if (data.descricao !== undefined) updatePayload.descricao = data.descricao;

    if (data.arquivo_modelo !== undefined)
      updatePayload.arquivo_modelo = data.arquivo_modelo;

    if (data.formato !== undefined) updatePayload.formato = data.formato;

    if (data.plataforma_origem !== undefined)
      updatePayload.plataforma_origem = data.plataforma_origem;

    if (data.data_modelagem !== undefined)
      updatePayload.data_modelagem = data.data_modelagem;

    if (data.responsavel_modelagem !== undefined)
      updatePayload.responsavel_modelagem = data.responsavel_modelagem;

    if (data.nivel_detalhamento !== undefined)
      updatePayload.nivel_detalhamento = data.nivel_detalhamento;

    if (data.coordenacao_com_outros_modelos !== undefined)
      updatePayload.coordenacao_com_outros_modelos =
        data.coordenacao_com_outros_modelos;

    if (data.comentarios !== undefined)
      updatePayload.comentarios = data.comentarios;

    updatePayload.updatedById = currentUser.id;

    await modelos_bim_asbuilt.update(updatePayload, { transaction });

    if (data.obra !== undefined) {
      await modelos_bim_asbuilt.setObra(
        data.obra,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await modelos_bim_asbuilt.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return modelos_bim_asbuilt;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const modelos_bim_asbuilt = await db.modelos_bim_asbuilt.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of modelos_bim_asbuilt) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of modelos_bim_asbuilt) {
        await record.destroy({ transaction });
      }
    });

    return modelos_bim_asbuilt;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const modelos_bim_asbuilt = await db.modelos_bim_asbuilt.findByPk(
      id,
      options,
    );

    await modelos_bim_asbuilt.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await modelos_bim_asbuilt.destroy({
      transaction,
    });

    return modelos_bim_asbuilt;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const modelos_bim_asbuilt = await db.modelos_bim_asbuilt.findOne(
      { where },
      { transaction },
    );

    if (!modelos_bim_asbuilt) {
      return modelos_bim_asbuilt;
    }

    const output = modelos_bim_asbuilt.get({ plain: true });

    output.obra = await modelos_bim_asbuilt.getObra({
      transaction,
    });

    output.clientes = await modelos_bim_asbuilt.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.obras,
        as: 'obra',

        where: filter.obra
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.obra
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  nome_obra: {
                    [Op.or]: filter.obra
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.nome_modelo) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'modelos_bim_asbuilt',
            'nome_modelo',
            filter.nome_modelo,
          ),
        };
      }

      if (filter.descricao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'modelos_bim_asbuilt',
            'descricao',
            filter.descricao,
          ),
        };
      }

      if (filter.arquivo_modelo) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'modelos_bim_asbuilt',
            'arquivo_modelo',
            filter.arquivo_modelo,
          ),
        };
      }

      if (filter.formato) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'modelos_bim_asbuilt',
            'formato',
            filter.formato,
          ),
        };
      }

      if (filter.plataforma_origem) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'modelos_bim_asbuilt',
            'plataforma_origem',
            filter.plataforma_origem,
          ),
        };
      }

      if (filter.responsavel_modelagem) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'modelos_bim_asbuilt',
            'responsavel_modelagem',
            filter.responsavel_modelagem,
          ),
        };
      }

      if (filter.nivel_detalhamento) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'modelos_bim_asbuilt',
            'nivel_detalhamento',
            filter.nivel_detalhamento,
          ),
        };
      }

      if (filter.comentarios) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'modelos_bim_asbuilt',
            'comentarios',
            filter.comentarios,
          ),
        };
      }

      if (filter.data_modelagemRange) {
        const [start, end] = filter.data_modelagemRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            data_modelagem: {
              ...where.data_modelagem,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            data_modelagem: {
              ...where.data_modelagem,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.coordenacao_com_outros_modelos) {
        where = {
          ...where,
          coordenacao_com_outros_modelos: filter.coordenacao_com_outros_modelos,
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.modelos_bim_asbuilt.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('modelos_bim_asbuilt', 'nome_modelo', query),
        ],
      };
    }

    const records = await db.modelos_bim_asbuilt.findAll({
      attributes: ['id', 'nome_modelo'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['nome_modelo', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.nome_modelo,
    }));
  }
};
